#include <os.h>
#include "console.h"
#include "input.h"
#include "extern.h"

unsigned char sscreen[320*240*2];
unsigned short int* orig_screen;
unsigned short int* screen;

int body() {
  char    mainbuf[LINELENGTH];
  char   *next;

  //open_score_file();
  initialize(NULL);
  /*if (argc < 2)
    initialize(NULL);
  else if (strcmp(argv[1], "-r") == 0)
    initialize((argc > 2) ? argv[2] : DEFAULT_SAVE_FILE);
  else
    initialize(argv[1]);*/
start:
  news();
  if(beenthere[position] <= ROOMDESC)
    beenthere[position]++;
  if(notes[LAUNCHED])
     crash(); /* decrements fuel & crash */
  if(matchlight) {
    nprint("Your match splutters out.\n");
    matchlight = 0;
  }
  if(!notes[CANTSEE] || testbit(inven, LAMPON) || testbit(location[position].objects, LAMPON)) {
    writedes();
    printobjs();
  } else
    nprint("It's too dark to see anything in here!\n");
  whichway(location[position]);
run:
  next = getcom(mainbuf, sizeof mainbuf, ">-: ",
      "Please type in something.");
  for (wordcount = 0; next && wordcount < NWORD - 1; wordcount++)
    next = getword(next, words[wordcount], -1);
  parse();
  switch (cypher()) {
  case -1:
    goto run;
  case 0:
    goto start;
  case 1:
    return 0;
    break;
  default:
    nprint("bad return from cypher()\n");
  }
}

main() {
  initScr();
  int size=320*240*2;
  orig_screen=getScreen();
  switchScrOffOn(0);
  unsigned short int* screen = is_cx?orig_screen:(unsigned char*) malloc(SCREEN_WIDTH*SCREEN_HEIGHT*2);
  if(!is_cx) setScreen(screen);
  if(!is_cx) startScrMode16();
  memcpy(screen,sscreen,size);
  switchScrOffOn(1);

  body();

  wait_key_pressed();
  switchScrOffOn(0);
  switchScrOffOn(0);
  if(!is_cx) {
    endScrMode16();
    setScreen(orig_screen);
    free(screen);
  } else {
    setScreen(orig_screen);
    if(screen!=orig_screen) free(screen);
  }
  switchScrOffOn(1);
}
